//*****************************************************************************
//! @file $Id: adc_drv.h 1140 2008-04-17 16:35:50Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧ق͈ȉ̊֐ײ؂̌^ϸۂ܂݂܂B
//!        - ADC (A/Dϊ)
//!        - ATmega32M1p
//!
//! ̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//!
//! @todo
//! @bug
//*****************************************************************************

#ifndef _ADC_DRV_H_
#define _ADC_DRV_H_

//_____ ݸٰ _______________________________________________________________

//! @defgroup ADC_module A/Dϊ핔
//! A/Dϊ핔
//! @{
//_____ ϸ ___________________________________________________________________

  //! @defgroup ADC_macros A/Dϊϸ
  //! iA/Dϊ̎gpϸ
  //! @{

	//! @defgroup Turn_on_adc A/DϊON
	//! A/DϊON
	//! @{
#define Adc_enable()						(ADCSRA |= (1<<ADEN))
	//! @}

	//! @defgroup ADC_alignement_configuration A/Dϊʐ`Ԑݒ
	//! A/Dϊʐ`Ԑݒ
	//! @{
#define Adc_right_adjust_result()			(ADMUX  &= ~(1<<ADLAR))
#define Adc_left_adjust_result()			(ADMUX  |=  (1<<ADLAR))
	//! @}

	//! @defgroup ADC_high_speed_mode_configuration A/Dϊ`Ԑݒ
	//! `ԐݒȀꍇA/Dϊg200kHzȂ܂B
	//! @{
#define Adc_enable_high_speed_mode()		(ADCSRB |=  (1<<ADHSM))
#define Adc_disable_high_speed_mode()		(ADCSRB &= ~(1<<ADHSM))
	//! @}

	//! @defgroup ADC_vref_configuration A/DϊVref`Ԑݒ
	//! Vref`Ԑݒ
	//! @{
#define Adc_enable_internal_vref()			(ADMUX  |=  ((1<<REFS1)|(1<<REFS0)) )
#define Adc_enable_external_vref()			(ADMUX  &= ~((1<<REFS1)|(1<<REFS0)) )
#define Adc_enable_vcc_vref()				( ADMUX  &= ~(1<<REFS1),\
											  ADMUX  |=  (1<<REFS0) )
	//! @}

	//! @defgroup ADC_it_configuration A/Dϊ荞݌`Ԑݒ
	//! A/Dϊ荞݌`Ԑݒ
	//! @{
#define Adc_enable_it()						(ADCSRA |=  (1<<ADIE) )
#define Adc_disable_it()					(ADCSRA &= ~(1<<ADIE) )
#define Adc_clear_flag()					(ADCSRA &=  (1<<ADIF) )
	//! @}

	//! @defgroup ADC_prescaler_configuration A/DϊOu`Ԑݒ
	//! A/DϊOu`Ԑݒ
	//! @{
#define Adc_set_prescaler(prescaler)		(ADCSRA &= ~((1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)),\
											 ADCSRA |=  (prescaler) )
	//! @}

	//! @defgroup ADC_channel_selection A/DϊّI
	//! ϊׂA/DϊّI
	//! @{
#define Adc_clear_mux()						(ADMUX  &= ~((1<<MUX4)|(1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0)) )
#define Adc_select_channel(channel) \
											(ADMUX = ( ADMUX & (~((1<<MUX4)|(1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0)))) \
													  | (channel) )
	//! @}

	//! @defgroup ADC_start_conversion A/DϊJn
	//! A/DϊJn
	//! @{

	  //! @defgroup ADC_start_normal_conversion A/Dϊʏϊ
	  //! `ԂŕϊJn
	  //! @{
#define Adc_start_conv()					(ADCSRA |= (1<<ADSC) )
#define Adc_start_conv_channel(channel)		(Adc_select_channel(channel),\
											 Adc_start_conv() )
	  //! @}

	  //! @defgroup ADC_start_idle_conversion A/DϊيJn
	  //! Gጸ`ԂA/DϊJn
	  //! @{
#define Adc_start_conv_idle()				 SMCR   |=  (1<<SM0)|(1<<SE) )
#define Adc_start_conv_idle_channel(chl)	(Adc_select_channel(chl),\
											 Adc_start_conv_idle() )
#define Adc_clear_sleep_mode()				(SMCR   &= ~(1<<SM0)|(1<<SE) )
	  //! @}
	//! @}

	//! @defgroup ADC_get_x_bits_result A/DϊnޯĂ̌ʎ擾
	//! nޯĂA/Dϊʎ擾
	//! @{
#define Adc_get_8_bits_result()				((U8)(ADCH))
#define Adc_get_10_bits_result()			((U16)(ADCL+((U16)(ADCH<<8))))
	//! @}

	//! @defgroup Turn_off_adc A/DϊOFF
	//! A/DϊOFF
	//! @{
#define Adc_disable()						(ADCSRA &= ~(1<<ADEN))
	//! @}

	//! @defgroup ϊIۂ̌
	//! ϊ󋵌
	//! @{
#define Adc_is_conv_finished()				((ADCSRA &  (1<<ADIF)) ? TRUE : FALSE)
#define Adc_is_conv_not_finished()			((ADCSRA | ~(1<<ADIF)) ? TRUE : FALSE)
#define Adc_wait_end_of_conversion()		while (ADCSRA & (1<<ADSC))
	//! @}

	//! @defgroup A/Dϊ`Ԑݒ
	//! A/Dϊ`Ԑݒ
	//! @{
#define Adc_config() \
  ADMUX  = (ADC_REF_SOURCE<<REFS0)| \
		   (ADC_ADLAR_VALUE<<ADLAR)| \
		   (ADC_CHANNEL<<MUX0); \
  ADCSRA = (ADC_ENABLE_BIT_VALUE<<ADEN)| \
		   (0<<ADSC)| \
		   (ADC_AUTO_TRIG_ENABLE_VALUE<<ADATE)| \
		   (0<<ADIF)| \
		   (ADC_INTERRUPT_ENABLE_VALUE<<ADIE)| \
		   (ADC_PRESCALER_SELECT_VALUE<<ADPS0); \
  ADCSRB = (ADC_HIGH_SPEED_MODE_VALUE<<ADHSM)| \
		   (ADC_CURRENT_SOURCE_ENABLE_VALUE<<ISRCEN)| \
		   (ADC_AREF_PIN_ENABLE_VALUE<<AREFEN)| \
		   (ADC_AUTO_TRIG_SOURCE<<ADTS0);
	//! @}

	//! @defgroup 0`Ԑݒ
	//! 0`Ԑݒ
	//! @{
#define Amp0_config() \
  AMP0CSR = (AMP0_ENABLE_VALUE<<AMP0EN)| \
			(AMP0_INPUT_SHUNT_VALUE<<AMP0IS)| \
			(AMP0_GAIN<<AMP0G0)| \
			(AMP0_CMP0_CONNECTION_VALUE<<AMPCMP0)| \
			(AMP0_CLOCK_SOURCE<<AMP0TS0);
	//! @}

	//! @defgroup 1`Ԑݒ
	//! 1`Ԑݒ
	//! @{

#define Amp1_config() \
  AMP1CSR = (AMP1_ENABLE_VALUE<<AMP1EN)| \
			(AMP1_INPUT_SHUNT_VALUE<<AMP1IS)| \
			(AMP1_GAIN<<AMP1G0)| \
			(AMP1_CMP1_CONNECTION_VALUE<<AMPCMP1)| \
			(AMP1_CLOCK_SOURCE<<AMP1TS0);
	//! @}

	//! @defgroup 2`Ԑݒ
	//! 2`Ԑݒ
	//! @{

#define Amp2_config() \
  AMP2CSR = (AMP2_ENABLE_VALUE<<AMP2EN)| \
			(AMP2_INPUT_SHUNT_VALUE<<AMP2IS)| \
			(AMP2_GAIN<<AMP2G0)| \
			(AMP2_CMP2_CONNECTION_VALUE<<AMPCMP2)| \
			(AMP2_CLOCK_SOURCE<<AMP2TS0);
	//! @}

  //! @}

//_____ ` __________________________________________________________________
// ADMUXp`
#define ADC_REF_EQ_AREF_PIN			0
#define ADC_REF_EQ_AVCC_PIN			1
#define ADC_REF_EQ_INT_VREF			3

#define ADC_RIGHT_ADJUST_RESULT		0
#define ADC_LEFT_ADJUST_RESULT		1

#define ADC_INPUT_ADC0				0
#define ADC_INPUT_ADC1				1
#define ADC_INPUT_ADC2				2
#define ADC_INPUT_ADC3				3
#define ADC_INPUT_ADC4				4
#define ADC_INPUT_ADC5				5
#define ADC_INPUT_ADC6				6
#define ADC_INPUT_ADC7				7
#define ADC_INPUT_ADC8				8
#define ADC_INPUT_ADC9				9
#define ADC_INPUT_ADC10				10
#define ADC_INPUT_TEMP_SENSOR		11
#define ADC_INPUT_VCCDIV4			12
#define ADC_INPUT_ISRC				13
#define ADC_INPUT_AMP0				14
#define ADC_INPUT_AMP1				15
#define ADC_INPUT_AMP2				16
#define ADC_INPUT_BANDGAP			17
#define ADC_INPUT_GND				18
 
// ADCSRAp`
#define ADC_DISABLE					0
#define ADC_ENABLE					1

#define ADC_AUTO_TRIG_DISABLE		0
#define ADC_AUTO_TRIG_ENABLE		1

#define ADC_INTERRUPT_DISABLE		0
#define ADC_INTERRUPT_ENABLE		1

#define ADC_DIV_CLOCK_BY_2			0
#define ADC_DIV_CLOCK_BY_4			2
#define ADC_DIV_CLOCK_BY_8			3
#define ADC_DIV_CLOCK_BY_16			4
#define ADC_DIV_CLOCK_BY_32			5
#define ADC_DIV_CLOCK_BY_64			6
#define ADC_DIV_CLOCK_BY_128		7

// ADCSRBp`
#define ADC_LOW_SPEED_MODE			0
#define ADC_HIGH_SPEED_MODE			1

#define ADC_CURRENT_SRC_DISABLE		0
#define ADC_CURRENT_SRC_ENABLE		1

#define ADC_AREF_PIN_DISABLE		0
#define ADC_AREF_PIN_ENABLE			1

#define ADC_FREE_RUNNING			0
#define ADC_TRIG_WITH_INT0			1
#define ADC_TRIG_WITH_TCM0			2
#define ADC_TRIG_WITH_TCOVF0		3
#define ADC_TRIG_WITH_TCM1			4
#define ADC_TRIG_WITH_TCOVF1		5
#define ADC_TRIG_WITH_TCCAPT1		6
#define ADC_TRIG_WITH_PSC0			7
#define ADC_TRIG_WITH_PSC1			8
#define ADC_TRIG_WITH_PSC2			9
#define ADC_TRIG_WITH_CMP0			10
#define ADC_TRIG_WITH_CMP1			11
#define ADC_TRIG_WITH_CMP2			12
#define ADC_TRIG_WITH_CMP3			13

#define AMP_DISABLE					0
#define AMP_ENABLE					1

#define AMP_SHUNT_DISABLE			0
#define AMP_SHUNT_ENABLE			1

#define AMP_GAIN_5					0
#define AMP_GAIN_10					1
#define AMP_GAIN_20					2
#define AMP_GAIN_40					3

#define AMP_CMP_DISCONNECTED		0
#define AMP_CMP_CONNECTED			1

#define AMP_CLOCK_EQ_ADC_DIV_8		0
#define AMP_CLOCK_EQ_TCCM0			1
#define AMP_CLOCK_EQ_TCOVF0			2
#define AMP_CLOCK_EQ_TCCMB1			3
#define AMP_CLOCK_EQ_TCOVF1			4
#define AMP_CLOCK_EQ_PSC0			5
#define AMP_CLOCK_EQ_PSC1			6
#define AMP_CLOCK_EQ_PSC2			7

//_____ ֐ __________________________________________________________________
   //! @defgroup ADC_low_level_functions A/Dϊʊ֐
   //! A/Dϊʊ֐
   //! @{

//! A/Dϊ`Ԑݒ`lɏ]A/Dϊ`Ԑݒ
//! DIDR0DIDR1ڼ޽ɂı۸ޓ͂Ƃĕϊ߰ĂIȂ΂
//! ȂƂɒӂĂB
//!
void init_adc(void);
void init_vref_source (void);
  //! @}
//! @}

#endif  // ADC_DRV_H
